#ifndef _MYFUNCS_H_INCLUDED_
#define _MYFUNCS_H_INCLUDED_

#include "fastonebigheader.h"

//double logsumexp(double x1, double x2);

/*inline double fastexp(double x)
{
   union
   {
      double d;
      int i[2];
   } u = {0};

   u.i[1] = (1512775 * x + (1072632447));
   return u.d > 0 ? u.d : 0;
}

inline double fastlog(double x)
{
   union
   {
      double d;
      int i[2];
   } u = {x};
   return (double)(u.i[1] - 1072632447) / 1512775;
}*/

inline double logsumexp(double x1, double x2)
{
   if (x1>x2)
      return x1 + fastlog(1+fastexp(x2-x1));
   else if (x2>x1)
      return x2 + fastlog(1+fastexp(x1-x2));
   else if (x1==mxGetInf())
      return mxGetInf();
   else if (x1==-mxGetInf())
      return -mxGetInf();
   else
      return x1 + fastlog(2);
}


#endif